local mod = RegisterMod( "Quatrefoil", 1);
local item = Isaac.GetItemIdByName( "Quatrefoil" )

local debug = false;
local game = Game();
luck_diff = 0;

function mod:start()
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:useItem()
	local	player = Isaac.GetPlayer(0);
	luck_diff = luck_diff + 100 - player.Luck;
	player:AddCacheFlags(CacheFlag.CACHE_LUCK);
	return true;
end

function mod.cancel()
	local player = Isaac.GetPlayer(0);
	if (luck_diff ~= 0) then
		luck_diff = 0;
		player:AddCacheFlags(CacheFlag.CACHE_LUCK);
	end
end

function mod:cache(entityPlayer, cacheFlag)
	if cacheFlag == CacheFlag.CACHE_LUCK then
		entityPlayer.Luck = entityPlayer.Luck + luck_diff;
	end
end

function mod:update()
	local player = Isaac.GetPlayer(0);
	if not player:HasCollectible(item) and luck_diff ~= 0 then
		luck_diff = 0;
		player:AddCacheFlags(CacheFlag.CACHE_LUCK);
	end
end

mod:AddCallback(ModCallbacks.MC_USE_ITEM, mod.useItem, item);
mod:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, mod.cancel);
mod:AddCallback(ModCallbacks.MC_POST_NEW_LEVEL, mod.cancel);
mod:AddCallback(ModCallbacks.MC_PRE_GAME_EXIT, mod.cancel);
mod:AddCallback(ModCallbacks.MC_EVALUATE_CACHE, mod.cache);
mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);
mod:AddCallback(ModCallbacks.MC_POST_UPDATE, mod.update);