local mod = RegisterMod("Five Leaf Clover", 1);
local item = Isaac.GetItemIdByName("Five Leaf Clover");

local debug = false;
local game = Game();

local playerforms = {
	{PlayerForm.PLAYERFORM_LORD_OF_THE_FLIES, false, CollectibleType.COLLECTIBLE_SMART_FLY, CollectibleType.COLLECTIBLE_BEST_BUD, CollectibleType.COLLECTIBLE_SKATOLE, CollectibleType.COLLECTIBLE_BLUEBABYS_ONLY_FRIEND, CollectibleType.COLLECTIBLE_BBF, CollectibleType.COLLECTIBLE_BIG_FAN, CollectibleType.COLLECTIBLE_DISTANT_ADMIRATION, CollectibleType.COLLECTIBLE_FOREVER_ALONE, CollectibleType.COLLECTIBLE_HALO_OF_FLIES, CollectibleType.COLLECTIBLE_HIVE_MIND, CollectibleType.COLLECTIBLE_MULLIGAN, CollectibleType.COLLECTIBLE_INFESTATION, CollectibleType.COLLECTIBLE_FRIEND_ZONE, CollectibleType.COLLECTIBLE_LOST_FLY, CollectibleType.COLLECTIBLE_PAPA_FLY, CollectibleType.COLLECTIBLE_OBSESSED_FAN, CollectibleType.COLLECTIBLE_JAR_OF_FLIES, CollectibleType.COLLECTIBLE_ANGRY_FLY},
	{PlayerForm.PLAYERFORM_GUPPY, false, CollectibleType.COLLECTIBLE_GUPPYS_HEAD, CollectibleType.COLLECTIBLE_GUPPYS_PAW, CollectibleType.COLLECTIBLE_GUPPYS_HAIRBALL, CollectibleType.COLLECTIBLE_DEAD_CAT, CollectibleType.COLLECTIBLE_GUPPYS_COLLAR, CollectibleType.COLLECTIBLE_GUPPYS_TAIL},
	{PlayerForm.PLAYERFORM_BOB, false, CollectibleType.COLLECTIBLE_BOBS_BRAIN, CollectibleType.COLLECTIBLE_IPECAC, CollectibleType.COLLECTIBLE_BOBS_ROTTEN_HEAD, CollectibleType.COLLECTIBLE_BOBS_CURSE},
	{PlayerForm.PLAYERFORM_BABY, false, CollectibleType.COLLECTIBLE_BROTHER_BOBBY, CollectibleType.COLLECTIBLE_SISTER_MAGGY, CollectibleType.COLLECTIBLE_HARLEQUIN_BABY, CollectibleType.COLLECTIBLE_HEADLESS_BABY, CollectibleType.COLLECTIBLE_LITTLE_STEVEN, CollectibleType.COLLECTIBLE_MONGO_BABY, CollectibleType.COLLECTIBLE_ROTTEN_BABY},
	{PlayerForm.PLAYERFORM_MUSHROOM, false, CollectibleType.COLLECTIBLE_GODS_FLESH, CollectibleType.COLLECTIBLE_ODD_MUSHROOM_RATE, CollectibleType.COLLECTIBLE_MINI_MUSH, CollectibleType.COLLECTIBLE_MAGIC_MUSHROOM, CollectibleType.COLLECTIBLE_ODD_MUSHROOM_DAMAGE, CollectibleType.COLLECTIBLE_ONE_UP, CollectibleType.COLLECTIBLE_BLUE_CAP},
	{PlayerForm.PLAYERFORM_EVIL_ANGEL, false, CollectibleType.COLLECTIBLE_PENTAGRAM, CollectibleType.COLLECTIBLE_BRIMSTONE, CollectibleType.COLLECTIBLE_MAW_OF_VOID, CollectibleType.COLLECTIBLE_THE_NAIL, CollectibleType.COLLECTIBLE_MARK, CollectibleType.COLLECTIBLE_PACT, CollectibleType.COLLECTIBLE_SPIRIT_NIGHT, CollectibleType.COLLECTIBLE_ABADDON},
	{PlayerForm.PLAYERFORM_POOP, false, CollectibleType.COLLECTIBLE_FLUSH, CollectibleType.COLLECTIBLE_POOP, CollectibleType.COLLECTIBLE_E_COLI},
	{PlayerForm.PLAYERFORM_ANGEL, false, CollectibleType.COLLECTIBLE_DEAD_DOVE, CollectibleType.COLLECTIBLE_SWORN_PROTECTOR, CollectibleType.COLLECTIBLE_BIBLE, CollectibleType.COLLECTIBLE_GUARDIAN_ANGEL, CollectibleType.COLLECTIBLE_HOLY_GRAIL, CollectibleType.COLLECTIBLE_HOLY_MANTLE, CollectibleType.COLLECTIBLE_MITRE, CollectibleType.COLLECTIBLE_ROSARY, CollectibleType.COLLECTIBLE_HALO},
	{PlayerForm.PLAYERFORM_DRUGS, false, CollectibleType.COLLECTIBLE_VIRUS, CollectibleType.COLLECTIBLE_SPEED_BALL, CollectibleType.COLLECTIBLE_GROWTH_HORMONES, CollectibleType.COLLECTIBLE_ROID_RAGE, CollectibleType.COLLECTIBLE_SPEED_BALL, CollectibleType.COLLECTIBLE_SYNTHOIL, CollectibleType.COLLECTIBLE_EXPERIMENTAL_TREATMENT},
	{PlayerForm.PLAYERFORM_MOM, false, CollectibleType.COLLECTIBLE_MOMS_BRA, CollectibleType.COLLECTIBLE_MOMS_PAD, CollectibleType.COLLECTIBLE_MOMS_BOTTLE_PILLS, CollectibleType.COLLECTIBLE_MOMS_WIG, CollectibleType.COLLECTIBLE_MOMS_EYE, CollectibleType.COLLECTIBLE_MOMS_PURSE, CollectibleType.COLLECTIBLE_MOMS_CONTACTS, CollectibleType.COLLECTIBLE_MOMS_KNIFE, CollectibleType.COLLECTIBLE_MOMS_HEELS, CollectibleType.COLLECTIBLE_MOMS_EYESHADOW, CollectibleType.COLLECTIBLE_MOMS_PERFUME, CollectibleType.COLLECTIBLE_MOMS_KEY, CollectibleType.COLLECTIBLE_MOMS_LIPSTICK, CollectibleType.COLLECTIBLE_MOMS_UNDERWEAR, CollectibleType.COLLECTIBLE_MOMS_COIN_PURSE, CollectibleType.COLLECTIBLE_MOMS_PEARLS},
	{PlayerForm.PLAYERFORM_BOOK_WORM, false, CollectibleType.COLLECTIBLE_ANARCHIST_COOKBOOK, CollectibleType.COLLECTIBLE_BOOK_REVELATIONS, CollectibleType.COLLECTIBLE_BOOK_OF_SECRETS, CollectibleType.COLLECTIBLE_BOOK_OF_SHADOWS, CollectibleType.COLLECTIBLE_HOW_TO_JUMP, CollectibleType.COLLECTIBLE_TELEPATHY_BOOK, CollectibleType.COLLECTIBLE_BOOK_OF_BELIAL, CollectibleType.COLLECTIBLE_BOOK_OF_SIN, CollectibleType.COLLECTIBLE_MONSTER_MANUAL},
	{PlayerForm.PLAYERFORM_SPIDERBABY, false, CollectibleType.COLLECTIBLE_SPIDER_BITE, CollectibleType.COLLECTIBLE_SPIDER_MOD, CollectibleType.COLLECTIBLE_SPIDERBABY, CollectibleType.COLLECTIBLE_BOX_OF_SPIDERS, CollectibleType.COLLECTIBLE_MUTANT_SPIDER, CollectibleType.COLLECTIBLE_SPIDER_BUTT},
	-- , {PlayerForm.PLAYERFORM_STOMPY, false, CollectibleType.COLLECTIBLE_LEO, CollectibleType.COLLECTIBLE_MAGIC_MUSHROOM}
};

local has_costume = false;

function mod:start()
	has_costume = false;
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
		for i = 1, #playerforms do
			playerforms[i][2] = false;
		end
	end
end

function mod:update()
	local player = Isaac.GetPlayer(0);

	if player:HasCollectible(item) then
		if not has_costume then
			has_costume = true;
			player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/five_leaf_clover.anm2"));
		end
		local should_cache = false;
	
		for i = 1, #playerforms do
			if player:HasPlayerForm(playerforms[i][1]) and playerforms[i][2] == false then
				should_cache = true;
				playerforms[i][2] = true;
				break;
			end
		end

		if should_cache then
			player:AddCacheFlags(CacheFlag.CACHE_LUCK);
			player:EvaluateItems();
		end
	end
end

-- WARNING, pretty hard code ahead --

function mod:newRoom()
	local player = Isaac.GetPlayer(0);
	
	if player:HasCollectible(item) and game:GetRoom():IsFirstVisit() then
		local collectible_count = 0;
		local entities = Isaac.GetRoomEntities();
		local should_reroll = true;
		local counter = 0;

		while (should_reroll and counter < 3) do
			counter = counter + 1;
			for i = 1, #entities do
				if entities[i].Type == EntityType.ENTITY_PICKUP and entities[i].Variant == PickupVariant.PICKUP_COLLECTIBLE then --for each pedestal on the room
					collectible_count = collectible_count + 1;

					for j = 1, #playerforms do --for each transformation
						if not player:HasPlayerForm(playerforms[j][1]) then -- if you don't have it
							for k = 3, #playerforms[j] do -- for each item of that transformation
								if entities[i].SubType == playerforms[j][k] then --if the item is a part of a transformation we don't have
									should_reroll = false; -- then we shouldn't reroll
									break;
								end
								if not should_reroll then break; end --break the loop to optimize
							end
						end
						if not should_reroll then break; end --break the loop to optimize
					end
				end
				if not should_reroll then break; end --break the loop to optimize
			end

			if should_reroll and collectible_count > 0 then
				player:UseActiveItem(CollectibleType.COLLECTIBLE_D6, false, true, true, false);
			end
		end
	end
end

function mod:cache(player, cacheFlag)
	if (player:HasCollectible(item) and cacheFlag == CacheFlag.CACHE_LUCK) then
		local count = 0;
		for i = 1, #playerforms do
			if player:HasPlayerForm(playerforms[i][1]) then
				count = count + 1;
			end 
		end
		player.Luck = player.Luck + count;
	end
end

mod:AddCallback( ModCallbacks.MC_POST_NEW_ROOM, mod.newRoom);
mod:AddCallback( ModCallbacks.MC_POST_UPDATE, mod.update);
mod:AddCallback( ModCallbacks.MC_POST_GAME_STARTED, mod.start);
mod:AddCallback( ModCallbacks.MC_EVALUATE_CACHE, mod.cache);