local mod = RegisterMod("Glyph of Consolation", 1);
local item = Isaac.GetItemIdByName("Glyph of Consolation");

local debug = false;
local game = Game();
local runes = {
Card.RUNE_HAGALAZ, Card.RUNE_JERA, Card.RUNE_EHWAZ, Card.RUNE_DAGAZ,
Card.RUNE_ANSUZ, Card.RUNE_PERTHRO, Card.RUNE_BERKANO, Card.RUNE_ALGIZ
};
local has_costume = false;

function mod:start()
	if game:GetFrameCount() == 0 then
		has_costume = false;
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:update()
	local player = Isaac.GetPlayer(0);

	if player:HasCollectible(item) and not has_costume then
		has_costume = true;
		player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/glyph_of_consolation.anm2"));
	end
end

function mod:entityTakeDamage(entity, dmgAmount, dmgFlag, source, dmgCountdownFrames)
	local player = entity:ToPlayer();
	if (player == null) then
		return
	end
	if (player:HasCollectible(item)) then
		local luckBased = false;
		if (player.Luck < 15) then
			if (Random() % 100 >= (80 - player.Luck * 2)) then
				luckBased = true;
			end
		else
			luckBased = (Random() % 2 == 0);
		end
		if (luckBased) then
			player:UseCard(runes[Random() % 8 + 1]);
		end
	end
end

mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);
mod:AddCallback(ModCallbacks.MC_POST_UPDATE, mod.update);
mod:AddCallback(ModCallbacks.MC_ENTITY_TAKE_DMG, mod.entityTakeDamage, EntityType.ENTITY_PLAYER);