local mod = RegisterMod("Happy Rock", 1);
local trinket = Isaac.GetTrinketIdByName("Happy Rock");

local debug = false;
local game = Game();

function mod:start()
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.350."..trinket);
		end
	end
end

function mod:disable_stonehead(npc) 
	local player = Isaac.GetPlayer(0);

	if player:HasTrinket(trinket) then
		npc.State = NpcState.STATE_UNIQUE_DEATH;
	else
		if not game:GetRoom():IsClear() then
			npc.State = NpcState.STATE_IDLE;
		end	
	end
end

function mod:disable_constant(npc)
	local player = Isaac.GetPlayer(0);
	local sprite = npc:GetSprite();

	if (npc.Variant == 0) then
		if player:HasTrinket(trinket) then
			if sprite:IsPlaying("ShootLeft") or sprite:IsPlaying("IdleLeft") then
				npc.I2 = 6;
				sprite:Play("CloseEyes");
			else
				if sprite:IsPlaying("ShootRight") or sprite:IsPlaying("IdleRight") then
					npc.I2 = 7;
					sprite:Play("CloseEyes");
				else
					if sprite:IsPlaying("ShootUp") or sprite:IsPlaying("IdleUp") then
						npc.I2 = 8;
						sprite:Play("CloseEyes");
					else
						if sprite:IsPlaying("ShootDown") or sprite:IsPlaying("IdleDown") then
							npc.I2 = 9;
							sprite:Play("CloseEyes");
						end
					end
				end
			end
		else
			if sprite:IsPlaying("ClosedEyes") and npc.I2 ~= 0 then
				sprite:Play("Appear");
			end
		end
		if sprite:IsPlaying("CloseEyes") and sprite:GetFrame() == 17 then
			sprite:Play("ClosedEyes");
		end
		if sprite:IsPlaying("Appear") and sprite:GetFrame() == 17 then
			if npc.I2 == 6 then
				sprite:Play("ShootLeft");
			else
				if npc.I2 == 7 then
					sprite:Play("ShootRight");
				else
					if npc.I2 == 8 then
						sprite:Play("ShootUp");
					else
						if npc.I2 == 9 then
							sprite:Play("ShootDown");
						end
					end
				end
			end
			npc.I2 = 0;
		end
	end
	if (npc.Variant == 10) then
		if player:HasTrinket(trinket) then
			npc.State = NpcState.STATE_UNIQUE_DEATH;
		elseif npc.State == NpcState.STATE_UNIQUE_DEATH and not game:GetRoom():IsClear() then
			npc.State = NpcState.STATE_IDLE;
		end
	end
	if (npc.Variant == 11) then
		if player:HasTrinket(trinket) then
			npc.State = NpcState.STATE_UNIQUE_DEATH;
		elseif (npc.State == NpcState.STATE_UNIQUE_DEATH) then
			npc.State = NpcState.STATE_IDLE;
		end	
	end
end

function mod:disable_brimstonehead(npc) 
	local player = Isaac.GetPlayer(0);
	local sprite = npc:GetSprite();
	
	if player:HasTrinket(trinket) then
		if sprite:IsPlaying("ShootLeft") then
			sprite:Play("IdleLeft");
		else
			if sprite:IsPlaying("ShootRight") then
				sprite:Play("IdleRight");
			else
				if sprite:IsPlaying("ShootUp") then
					sprite:Play("IdleUp");
				else
					if sprite:IsPlaying("ShootDown") then
						sprite:Play("IdleDown");
					end
				end
			end
		end
	else
		if sprite:IsPlaying("IdleLeft") then
			sprite:Play("ShootLeft");
		else
			if sprite:IsPlaying("IdleRight") then
				sprite:Play("ShootRight");
			else
				if sprite:IsPlaying("IdleUp") then
					sprite:Play("ShootUp");
				else
					if sprite:IsPlaying("IdleDown") then
						sprite:Play("ShootDown");
					end
				end
			end
		end
	end
end

function mod:disable_eye_grimaces(npc) 
	local player = Isaac.GetPlayer(0);

	if player:HasTrinket(trinket) then
		npc.State = NpcState.STATE_IDLE;
	else
		if not game:GetRoom():IsClear() then
			npc.State = NpcState.STATE_MOVE;
		end	
	end
end

function mod:disable_sucky_grimaces(npc) 
	local player = Isaac.GetPlayer(0);
	local sprite = npc:GetSprite();
	
	if player:HasTrinket(trinket) then
		npc.State = NpcState.STATE_INIT;
		sprite:Play("Idle", 0);
		sprite:RemoveOverlay();
	else
		if (npc.State == NpcState.STATE_INIT) then
			npc.State = NpcState.STATE_IDLE;
		end
	end
end

mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);
mod:AddCallback(ModCallbacks.MC_NPC_UPDATE, mod.disable_stonehead, EntityType.ENTITY_STONEHEAD); -- basic and vomit stonehead
mod:AddCallback(ModCallbacks.MC_NPC_UPDATE, mod.disable_eye_grimaces, EntityType.ENTITY_STONE_EYE); --Eyeball shooting lasers
mod:AddCallback(ModCallbacks.MC_NPC_UPDATE, mod.disable_constant, EntityType.ENTITY_CONSTANT_STONE_SHOOTER); -- constant shooting grimace
mod:AddCallback(ModCallbacks.MC_NPC_UPDATE, mod.disable_brimstonehead, EntityType.ENTITY_BRIMSTONE_HEAD); -- constant brimstone grimace
mod:AddCallback(ModCallbacks.MC_NPC_UPDATE, mod.disable_sucky_grimaces, EntityType.ENTITY_GAPING_MAW); -- sucky grimace
mod:AddCallback(ModCallbacks.MC_NPC_UPDATE, mod.disable_sucky_grimaces, EntityType.ENTITY_BROKEN_GAPING_MAW); -- broken sucky grimace